#version 150

#moj_import <minecraft:fog.glsl>

uniform sampler2D Sampler0;

uniform vec4 ColorModulator;

in vec2 texCoord0;
in float vertexDistance;
in vec4 vertexColor;

uniform float FogStart;
uniform float FogEnd;
uniform vec4 FogColor;

out vec4 fragColor;

void main() {
	float fogStart = 0.0;
	float fogEnd = FogEnd;
	float fogValue = 0.0;
	if (vertexDistance > fogStart) { fogValue = vertexDistance < fogEnd ? smoothstep(fogStart, fogEnd, vertexDistance) : 1.0; }
	
    fragColor = vec4(mix(vertexColor.rgb, FogColor.rgb, fogValue * FogColor.a), vertexColor.a - fogValue);
    
}
